> ## Documentation Index
> Fetch the complete documentation index at: https://private-7c7dfe99-detect-table-modification.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Create reverse private endpoint

> Create a new reverse private endpoint.

Create a new reverse private endpoint.


## OpenAPI

````yaml /_specs/cloud-openapi.json post /v1/organizations/{organizationId}/services/{serviceId}/clickpipesReversePrivateEndpoints
openapi: 3.1.2
info:
  title: OpenAPI spec for ClickHouse Cloud
  version: '1.0'
  contact:
    name: ClickHouse Support
    url: >-
      https://clickhouse.com/docs/en/cloud/manage/openapi?referrer=openapi-910487
    email: support@clickhouse.com
servers:
  - url: https://api.clickhouse.cloud
security:
  - basicAuth: []
tags:
  - name: Organization
  - name: User management
  - name: Billing
  - name: Role Management
  - name: Service
  - name: Backup
  - name: OpenAPI
  - name: Prometheus
  - name: ClickPipes
  - name: ClickStack
  - name: Postgres
paths:
  /v1/organizations/{organizationId}/services/{serviceId}/clickpipesReversePrivateEndpoints:
    post:
      tags:
        - ClickPipes
      summary: Create reverse private endpoint
      description: Create a new reverse private endpoint.
      operationId: clickPipeReversePrivateEndpointCreate
      parameters:
        - in: path
          name: organizationId
          description: ID of the organization that owns the service.
          required: true
          schema:
            type: string
            format: uuid
        - in: path
          name: serviceId
          description: ID of the service that owns the Reverse Private Endpoint.
          required: true
          schema:
            type: string
            format: uuid
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateReversePrivateEndpoint'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: number
                    description: HTTP status code.
                    example: 200
                  requestId:
                    type: string
                    description: Unique id assigned to every request. UUIDv4
                    format: uuid
                  result:
                    $ref: '#/components/schemas/ReversePrivateEndpoint'
        '400':
          description: >-
            The request cannot be processed due to a client error. Please verify
            your request parameters and try again.
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: number
                    description: HTTP status code.
                    example: 400
                  error:
                    type: string
                    description: Detailed error description.
                  requestId:
                    type: string
                    description: Unique id assigned to every request. UUIDv4
                    format: uuid
        '500':
          description: >-
            An internal server error has occurred. If this issue persists,
            please contact ClickHouse Cloud support for assistance.
          content:
            application/json:
              schema:
                type: object
                properties:
                  status:
                    type: integer
                    description: HTTP status code.
                    example: 500
                  error:
                    type: string
                    description: Detailed error description.
                  requestId:
                    type: string
                    description: Unique id assigned to every request. UUIDv4
                    format: uuid
components:
  schemas:
    CreateReversePrivateEndpoint:
      properties:
        description:
          description: >-
            Reverse private endpoint description. Maximum length is 255
            characters.
          type: string
          example: My reverse private endpoint
        type:
          description: Reverse private endpoint type.
          type: string
          enum:
            - VPC_ENDPOINT_SERVICE
            - VPC_RESOURCE
            - MSK_MULTI_VPC
            - GCP_PSC_SERVICE_ATTACHMENT
          example: VPC_ENDPOINT_SERVICE
        vpcEndpointServiceName:
          description: VPC endpoint service name.
          type:
            - string
            - 'null'
          example: com.amazonaws.vpce.us-east-1.vpce-svc-12345678901234567
        vpcResourceConfigurationId:
          description: VPC resource configuration ID. Required for VPC_RESOURCE type.
          type:
            - string
            - 'null'
          example: rcfg-12345678901234567
        vpcResourceShareArn:
          description: VPC resource share ARN. Required for VPC_RESOURCE type.
          type:
            - string
            - 'null'
          example: >-
            arn:aws:ram:us-east-1:123456789012:resource-share/share-12345678901234567
        mskClusterArn:
          description: MSK cluster ARN. Required for MSK_MULTI_VPC type.
          type:
            - string
            - 'null'
          example: arn:aws:kafka:us-east-1:123456789012:cluster/my-cluster
        mskAuthentication:
          description: MSK cluster authentication type. Required for MSK_MULTI_VPC type.
          type:
            - string
            - 'null'
          enum:
            - SASL_IAM
            - SASL_SCRAM
          example: SASL_IAM
        gcpServiceAttachment:
          description: >-
            Private Preview. GCP PSC service attachment URI. Required for
            GCP_PSC_SERVICE_ATTACHMENT type. Format:
            projects/{project}/regions/{region}/serviceAttachments/{name}.
          type:
            - string
            - 'null'
          example: >-
            projects/my-project/regions/us-central1/serviceAttachments/my-service
        customPrivateDnsMappings:
          type: array
          description: >-
            Optional private DNS names for Reverse Private Endpoint. Can be used
            as data source destination address. Must be unique across the
            ClickHouse service.

            Generally available for Google Private Service Connect (PSC). For
            AWS PrivateLink (VPC endpoint service and VPC resource), available
            in Private Preview; contact ClickHouse support to enable it for your
            service. Not supported for MSK multi-VPC.

            Supports exact names and leading wildcard names such as
            *.example.com
          items:
            $ref: '#/components/schemas/CustomPrivateDnsMapping'
          example:
            - privateDnsName: my-service.example.com
            - privateDnsName: '*.example.com'
    ReversePrivateEndpoint:
      properties:
        description:
          description: >-
            Reverse private endpoint description. Maximum length is 255
            characters.
          type: string
          example: My reverse private endpoint
        type:
          description: Reverse private endpoint type.
          type: string
          enum:
            - VPC_ENDPOINT_SERVICE
            - VPC_RESOURCE
            - MSK_MULTI_VPC
            - GCP_PSC_SERVICE_ATTACHMENT
          example: VPC_ENDPOINT_SERVICE
        vpcEndpointServiceName:
          description: VPC endpoint service name.
          type:
            - string
            - 'null'
          example: com.amazonaws.vpce.us-east-1.vpce-svc-12345678901234567
        vpcResourceConfigurationId:
          description: VPC resource configuration ID. Required for VPC_RESOURCE type.
          type:
            - string
            - 'null'
          example: rcfg-12345678901234567
        vpcResourceShareArn:
          description: VPC resource share ARN. Required for VPC_RESOURCE type.
          type:
            - string
            - 'null'
          example: >-
            arn:aws:ram:us-east-1:123456789012:resource-share/share-12345678901234567
        mskClusterArn:
          description: MSK cluster ARN. Required for MSK_MULTI_VPC type.
          type:
            - string
            - 'null'
          example: arn:aws:kafka:us-east-1:123456789012:cluster/my-cluster
        mskAuthentication:
          description: MSK cluster authentication type. Required for MSK_MULTI_VPC type.
          type:
            - string
            - 'null'
          enum:
            - SASL_IAM
            - SASL_SCRAM
          example: SASL_IAM
        gcpServiceAttachment:
          description: >-
            Private Preview. GCP PSC service attachment URI. Required for
            GCP_PSC_SERVICE_ATTACHMENT type. Format:
            projects/{project}/regions/{region}/serviceAttachments/{name}.
          type:
            - string
            - 'null'
          example: >-
            projects/my-project/regions/us-central1/serviceAttachments/my-service
        customPrivateDnsMappings:
          type: array
          description: >-
            Optional private DNS names for Reverse Private Endpoint. Can be used
            as data source destination address. Must be unique across the
            ClickHouse service.

            Generally available for Google Private Service Connect (PSC). For
            AWS PrivateLink (VPC endpoint service and VPC resource), available
            in Private Preview; contact ClickHouse support to enable it for your
            service. Not supported for MSK multi-VPC.

            Supports exact names and leading wildcard names such as
            *.example.com
          items:
            $ref: '#/components/schemas/CustomPrivateDnsMapping'
          example:
            - privateDnsName: my-service.example.com
            - privateDnsName: '*.example.com'
        id:
          description: Reverse private endpoint ID.
          type: string
          format: uuid
          example: 12345678-1234-1234-1234-123456789012
        serviceId:
          description: ClickHouse service ID reverse private endpoint is associated with.
          type: string
          format: uuid
          example: 12345678-1234-1234-1234-123456789012
        endpointId:
          description: Reverse private endpoint endpoint ID.
          type: string
          example: vpce-12345678901234567
        dnsNames:
          type: array
          description: Reverse private endpoint internal DNS names.
          items:
            type: string
          example:
            - >-
              vpce-12345678901234567-abcdefg.execute-api.us-east-1.vpce.amazonaws.com
        privateDnsNames:
          type: array
          description: Reverse private endpoint private DNS names.
          items:
            type: string
          example:
            - >-
              vpce-12345678901234567-abcdefg.execute-api.us-east-1.vpce.amazonaws.com
        status:
          description: Reverse private endpoint status.
          type: string
          enum:
            - Unknown
            - Provisioning
            - Deleting
            - Ready
            - Failed
            - PendingAcceptance
            - Rejected
            - Expired
          example: Ready
    CustomPrivateDnsMapping:
      properties:
        privateDnsName:
          description: >-
            Optional private DNS names for Reverse Private Endpoint. Can be used
            as data source destination address. Must be unique across the
            ClickHouse service.

            Generally available for Google Private Service Connect (PSC). For
            AWS PrivateLink (VPC endpoint service and VPC resource), available
            in Private Preview; contact ClickHouse support to enable it for your
            service. Not supported for MSK multi-VPC.

            Supports exact names and leading wildcard names such as
            *.example.com
          type: string
          example: '*.my-service.example.com'
  securitySchemes:
    basicAuth:
      type: http
      scheme: basic
      description: >-
        Use key ID and key secret obtained in ClickHouse Cloud console:
        https://clickhouse.com/docs/cloud/manage/openapi

````